var player = false;
var transfer = false;
var inactivityTimer = 0;
var manager = false;

var service_timer = false;

var mouse_click_start_time = 0;

document.addEventListener('deviceready', function(){
    window.plugins.insomnia.keepAwake();
    var appDir = "";
    var systemInfo = navigator.userAgent || navigator.vendor || window.opera;
    systemInfo = systemInfo.toLowerCase();
    var uuid = device.uuid;
    console.log("UUID is : "+uuid);
    if(systemInfo.match(/iphone/i)
          || systemInfo.match(/ipad/i)
          || systemInfo.match(/ipod/i)){
            appDir = cordova.file.documentsDirectory+"ADmira/";
    }else if(systemInfo.match(/android/i)){
        appDir = cordova.file.externalRootDirectory+"ADmira/";
    }
    $.get(appDir+'app/cordova.ver', function(data, status) {  
       console.log("File request status: "+status); 
    }).done(function() {
        console.log("System is updatable.");
        document.location = appDir+"app/cordova.html";
        console.log( "second success" );
    }).fail(function() {
        console.log("has no external installation");
        $(document).ready(function(){  
            try{
              if(!player){
                  player = new PlayerController();
                  $(player).on("PlayerDataLoaded",onPlayerDataLoaded);
                  player.init();
              }        
            }catch(e){
              console.log("Unable to start player");
              try{
                if(player.platform == "ANDROID"){
                    cordova.plugins.backgroundMode.enable();
                }
                if(!transfer){
                    transfer = new TransferService();
                    transfer.init(player.version);
                    transfer.setLogger(player.logger);
                }
                transfer.update(player.timestamp);
                transfer.activateLogger(player.debug);
              }catch(e){
                console.log("Unable to start transfer");
              }
              try{
                schedule = player.config.getScheduleConfig();
              }catch(e){
                console.log("No Schedule !");
              }
              try{
                if(!manager){
                    manager = new ManagerService();
                    manager.init();
                    manager.setLogger(player.logger);
                    try{
                      transfer.onUpdatedManagerInterval = function(interval){
                        console.log("Checking ManagerService Interval");
                        manager.checkInterval(interval);
                      };
                    }catch(e){
                      console.log("Could not check interval for management");
                    }
                }
                manager.update(schedule);
                manager.activateLogger(player.debug);
              }catch(e){
                console.log("Unable to start manager");
              }
            }
        });
    });
}, false);  

function onPlayerDataLoaded(){  
  try{
    if(player.platform == "ANDROID"){
        cordova.plugins.backgroundMode.enable();
    }
    if(!transfer){
        transfer = new TransferService();
        transfer.init(player.version);
        transfer.setLogger(player.logger);
    }
    transfer.update(player.timestamp);
    transfer.activateLogger(player.debug);
  }catch(e){
    console.log("Unable to start transfer");
  }
  try{
    schedule = player.config.getScheduleConfig();
  }catch(e){
    console.log("No Schedule !");
  }
  try{
    if(!manager){
        manager = new ManagerService();
        manager.init();
        manager.setLogger(player.logger);
        try{
          transfer.onUpdatedManagerInterval = function(interval){
            console.log("Checking ManagerService Interval");
            manager.checkInterval(interval);
          };
        }catch(e){
          console.log("Could not check interval for management");
        }
    }
    manager.update(schedule);
    manager.activateLogger(player.debug);
  }catch(e){
    console.log("Unable to start manager");
  }
}

function service(){
	if(player){
		player.service();
		try{
			if(transfer){
					transfer.updateInfo(player.name,player.getInfo());
			}
		}catch(e){
			console.log("Unable to update player info for transfer");
		}
	}
}

window.addEventListener("touchstart", onTouchScreenStart, false);
window.addEventListener("mousedown", onTouchScreenStart, false);


function onTouchScreenStart(event) {
    //console.log("Start MultiTouch : "+event.targetTouches.length);
    mouse_click_start_time = new Date().getTime();
}

window.addEventListener("touchend", onTouchScreenEnd, false);
window.addEventListener("mouseup", onTouchScreenEnd, false);

function onTouchScreenEnd(event) {
    //console.log("End MultiTouch : "+event.targetTouches.length);
    //navigator.app.exitApp();
    var mousedown_time = new Date().getTime() - mouse_click_start_time;
    if(mousedown_time > 5000){
      //player.OS.force_screensaver_mode(5);
      /*
      if(typeof(player.config) !== "undefined"){
        if(player.config.getQuitOnClick()){
          player.OS.quit(true,true);
        }
      }
      */
      player.OS.quit(true,true);
    }else{
      if(typeof(player.config) !== "undefined"){
        if(player.registered){
          if(player.config.getQuitOnClick()){
              player.OS.quit();
          }
        }
      }
    }

    if(typeof(event.targetTouches) != "undefined"){
      if (event.targetTouches.length >= 3) {
        /*
          logger_visible = !logger_visible;
          player.setLogger(player.log_window);
          player.activateLogger(logger_visible);
          transfer.setLogger(player.log_window);
          transfer.activateLogger(logger_visible);
          manager.setLogger(player.log_window);
          manager.activateLogger(logger_visible);
          */
          if(!player.core_setup_window_showing && !player.proxy_setup_window_showing){
            player.toggleCoreSetupWindow();
          }else{
            if(player.core_setup_window_showing){
              player.toggleCoreSetupWindow();
            }
            player.toggleProxySetupWindow();
          }
      }
    }
}
