function FileManagerService(){
    if(arguments.callee._singletonInstance){
	    return arguments.callee._singletonInstance;
	}
	arguments.callee._singletonInstance = this;

	var self = this; self.name = "FileManagerService"; // MANDATORY

    this.MAX_DOWNLOAD_RETRIES = 5;
    this.downloading = false;
    this.archive = false;
    this.archive_index = 0;
    this.busy = false;
    this.busyCount = 0;
    this.busyCountXML = 0;
    this.library = [];
    this.lastLibraryCount = -1;
    this.initiated = false;
    
    this.download_list = [];
    this.selecting = false;
    this.select_delay = 100;
    
    this.review_index = 0;
    this.review_download_list_interval = 0;
    
    this.last_files_length = 0;
    
    this.weekly_archive_loaded = false;
    
    this.reviewer_checker_interval = 0;
    this.reviewer_checker_delay = 90000;

    this.update = function(new_archive){
        self.archive = null;
        self.archive = [];
        self.getWeeklyArchive();
        
        if(self.reviewer_checker_interval == 0){
          self.reviewer_checker_interval = setTimeout(self.checkReviewer,self.reviewer_checker_delay);
        }
    };
    
    this.checkDataXML = function(timestamp,callback){
        self.OS.fileExists(self.ROUTES['XML'].path+timestamp+".zip", function(exists,file_ref,index){
            if(!exists){
                self.log("Downloading ... busy... "+self.busyCountXML);
                self.busyCountXML++;
                if(self.busyCountXML > 5){
                    self.downloading = false;
                }
            }else{
                self.downloading = false;
                self.busyCountXML = 0;
                self.OS.unzipFile(self.ROUTES['XML'].path+timestamp+".zip",self.ROUTES['XML'].path,function(ok,file_ref,params){
                    self.OS.writeFile(self.ROUTES['XML'].path+self.ROUTES['TIMESTAMP'].path,params.xml_timestamp);
                    self.OS.deleteFile(self.ROUTES['XML'].path+timestamp+".zip");
                    if(typeof(callback) !== "undefined"){
                        callback(ok,params);
                    }
                },{'xml_timestamp':timestamp});
            }
        });
    };
    
    this.downloadDataXML = function(timestamp,callback,callback_error){
        self.downloading = true;
        var url = self.api_connector.buildUrl(self.api_url,self.api_ver,"player/download_playlist_week/id/"+self.core_id+ "/zip/1/"+self.getDate(true).getTime());
        var options = {'filename':timestamp+'.zip','xml_timestamp':timestamp};
        self.OS.downloadFile(url,self.ROUTES['XML'].path,function(ok,file_ref,params){
            self.downloading = false;
            self.busyCountXML = 0;
            if(ok){
                self.log("Playlist Files Download OK : "+url+" to "+self.ROUTES['XML'].path);
                var file_options = params;
                self.OS.readDirectory(self.ROUTES['XML'].path,function(files){
                  var ext = "";
                  var filename = "";
                  for(var i=0;i<files.length;i++){
                    ext = filename = files[i];
                    self.log("/xmls/ : "+filename);
                    if(filename != ""){
                      if(self.platform == "SOC"){
                          filename = filename.substring(2,filename.length-1);
                      }
                    }
                    filename = filename.substring(0,filename.lastIndexOf("."));
                    ext = ext.substring(ext.lastIndexOf("."),ext.length);
                    if(ext == ".xml"){
                      if(filename.lastIndexOf("_") > 0){
                        self.OS.deleteFile(self.ROUTES['XML'].path+files[i]);
                      }
                    }
                  }
                  self.OS.unzipFile(self.ROUTES['XML'].path+timestamp+".zip",self.ROUTES['XML'].path,function(ok,file_ref,params){
                      self.OS.deleteFile(self.ROUTES['XML'].path+timestamp+".zip");
                      if(ok){
                        self.resetMaxRetries();
                      }
                      if(typeof(callback) !== "undefined"){
                          callback(ok,params);
                      }
                  },file_options);
                });
            }else{
            	self.log(self.ERROR['FILE_MANAGER_SERVICE']+1,self.name+": Function downloadDataXML() failed : could not Download XML Week ");
                self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+1,self.name+": Function downloadDataXML() failed : could not Download XML Week. Try to set Unsecure Connection for download");
                self.log("Error downloading XML Week. Try to set Unsecure Connection for download");
                self.api_connector.setSecureConnection(false);
                if(typeof(callback_error) !== "undefined"){
                    callback_error(ok,params);
                }
            }
        },options);
    };
    
    this.downloadDataDayXML = function(timestamp,callback,callback_error){
        self.downloading = true;
        var url = self.api_connector.buildUrl(self.api_url,self.api_ver,"player/download_playlist/id/"+self.core_id+ "/zip/1/"+self.getDate(true).getTime());
        var options = {'filename':timestamp+'.zip','xml_timestamp':timestamp};
        self.OS.downloadFile(url,self.ROUTES['XML'].path,function(ok,file_ref,params){
            self.downloading = false;
            self.busyCountXML = 0;
            if(ok){
                self.log("Playlist Files Download OK : "+url+" to "+self.ROUTES['XML'].path);
                var file_options = params;
                self.OS.unzipFile(self.ROUTES['XML'].path+timestamp+".zip",self.ROUTES['XML'].path,function(ok,file_ref,params){
                    try{
                      self.OS.readFile(self.ROUTES['XML'].path+"datos.xml",function(data,file_ref,params){
                        if(data != ""){
                          self.OS.writeFile(self.ROUTES['XML'].path+""+self.getDayOfWeek()+".xml",data,function(ok){
                            if(ok){
                              self.resetMaxRetries();
                            }
                            if(typeof(callback) !== "undefined"){
                                callback(ok,params);
                            }
                          },params);
                        }else{
                          if(typeof(callback) !== "undefined"){
                              callback(false,params);
                          }
                        }
                      },params);
                    }catch(e){
                      if(typeof(callback) !== "undefined"){
                          callback(false,params);
                      }
                    }
                    try{
                      self.OS.readDirectory(self.ROUTES['XML'].path,self.checkMultiplayerXMLs);
                    }catch(e){
                      console.log(e);
                    }
                },file_options);
            }else{
            	self.log(self.ERROR['FILE_MANAGER_SERVICE']+1,self.name+": Function downloadDataXML() failed : could not Download XML Week ");
                self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+1,self.name+": Function downloadDataXML() failed : could not Download XML Week ");
                if(typeof(callback_error) !== "undefined"){
                    callback_error(ok,params);
                }
            }
        },options);
    };
    
    this.checkMultiplayerXMLs = function(files){
      for(var i=0;i<files.length;i++){
        var file = files[i];
        if(file.indexOf("_data") >= 0){
          try{
            var dow = self.getDayOfWeek();
            var new_name = file.replace("_data","_"+dow);
            self.OS.moveFile(self.OS.rootDir+self.ROUTES['XML'].path+file,self.OS.rootDir+self.ROUTES['XML'].path+new_name);
          }catch(e){
              console.log("Failed moving XML Multiplayer data file.");
          }
        }
      }
    };
    
    this.resetMaxRetries = function(){
      try{
        for(var k=0;k<self.archive.length;k++){
          if(!self.archive[k].downloaded){
            var status_for = {
                id:self.archive[k].identifier,
                player:self.core_id,
                name:self.name
            };
            self.getStatusFile(status_for,function(data,params){
              var download_status = {
                  id: self.archive[params.index].identifier,
                  player: self.core_id,
                  name: self.name,
                  filename: self.archive[params.index].identifier+"/"+self.archive[params.index].filename,
                  tstamp: self.archive[params.index].tstamp,
                  retries: 0
              };
              self.saveStatusFile(download_status);
            },{index:k});
          }
        }
      }catch(e){
        self.log("Impossible to reset Download Max Retries");
      }
    };
    
    this.checkReviewer = function(){
      console.log("Force Review File List");
      clearTimeout(self.reviewer_checker_interval);
      if(!self.selecting){
        self.review_download_list_interval = setTimeout(self.reviewDownloadList,self.select_delay);
      }
      self.reviewer_checker_interval = setTimeout(self.checkReviewer,self.reviewer_checker_delay);
    };
    
    this.reviewDownloadList = function(){
      clearTimeout(self.review_download_list_interval);
      self.selecting = true;
      self.log("Reviewing Index : "+self.review_index);
      try{
        if(typeof(self.archive[self.review_index]) !== "undefined"){
          self.log(self.archive[self.review_index].filename+" Downloaded ? "+self.archive[self.review_index].downloaded);
          if(self.archive[self.review_index].filename.lastIndexOf(".node_.js") > 0 || self.archive[self.review_index].filename.lastIndexOf(".node.js") > 0){
            try{
              self.OS.loadExternalApp(self.ROUTES['CONTENT'].path+self.archive[self.review_index].destination+self.archive[self.review_index].filename);
            }catch(e){
              self.log("OS does not support loading External NodeJS Apps");
            }
          }
          if(!self.archive[self.review_index].downloaded){
            if(self.download_list.indexOf(self.review_index) < 0){
              self.download_list.push(self.review_index);
            }
          }else{
            if(typeof(self.archive[self.review_index]) !== "undefined"){
                self.log("Checking : "+self.ROUTES['CONTENT'].path+self.archive[self.review_index].destination+self.archive[self.review_index].filename);    
                self.OS.fileExists(self.ROUTES['CONTENT'].path+self.archive[self.review_index].destination+self.archive[self.review_index].filename, function(exists,file_ref,index){
                  if(exists){
                    self.log("checkDownloadedFile : "+self.archive[index].filename+" already exists ...");  
                    self.archive[index].downloaded = true;
                    var status_for = {
                        id:self.archive[index].identifier,
                        player:self.core_id,
                        name:self.name
                    };
                    self.getStatusFile(status_for,self.checkFileTimestamp,{index:index});
                  }else{
                    self.log("checkDownloadedFile : "+self.archive[index].filename+" does not exists ...");  
                    self.archive[index].downloaded = false;
                    if(self.download_list.indexOf(index) < 0){
                      self.download_list.push(index);
                    }
                  }
                },self.review_index);
            }
          }
        }
        self.review_index++;
        if(self.review_index >= self.archive.length){
          self.review_index = 0;
          self.selecting = false;
          $(self).trigger("FileManagerFree",[false,true]);
        }else{
          self.review_download_list_interval = setTimeout(self.reviewDownloadList,self.select_delay);
        }
      }catch(e){
        console.log("EXCEPTION Selecting");
        console.log(e);
        self.selecting = false;
      }
    };
        
    this.startDownloadFile = function(data,params){
      if(typeof(params.index) !== "undefined"){
        self.busy = true;
        var url = "";
        var content_type = "";
        
        if(typeof(self.archive[params.index].attachments) == "boolean"){
          content_type = "Adjunto";
          url = self.archive[params.index].url;
        }else{
          content_type = "Video";
          url = self.api_connector.protocol+self.api_server_url+self.archive[params.index].url;
        }
        var proceed_download = false;
        var checked_download_retries = 0;
        if(typeof(data) == "boolean" && !data){
          proceed_download = true;
        }else{
          if(typeof(data.retries) !== "undefined"){
            checked_download_retries = data.retries;
          }
          if(typeof(data.tstamp) !== "undefined"){
              if(data.tstamp != self.archive[params.index].tstamp){
                self.log("New Timestamps : "+data.tstamp+" != "+self.archive[params.index].tstamp+" for file ... setting retries to 0 to start downloading again.");
                checked_download_retries = 0;
              }
          }
          // DISABLE MAX RETRIES
          //if(checked_download_retries < self.MAX_DOWNLOAD_RETRIES){
            proceed_download = true;
          //}
        }
        if(proceed_download){
          self.log("Downloading : "+url);
          var parameters = {
              file_ref:self.archive[params.index].filename,
              content_id:self.archive[params.index].id,
              content_type:content_type,
              hash:self.archive[params.index].hash,
              retries: checked_download_retries,
              index: params.index
          };
          self.log("File Download Destination : "+self.archive[params.index].destination+self.archive[params.index].filename);
          self.OS.makeDir(self.ROUTES['CONTENT'].path+self.archive[params.index].destination,function(ok,dir_ref,download_parameters){
            self.OS.fileExists(self.ROUTES['CONTENT'].path+self.archive[download_parameters.index].filename,function(exists,file_ref,file_params){
              var moved = false;
              if(exists){
                if(typeof(file_params.index) !== "undefined"){
                  moved = true;
                  self.busy = false;
                  self.log("Trying to move : "+self.ROUTES['CONTENT'].path+self.archive[file_params.index].filename);
                  self.log("to "+self.ROUTES['CONTENT'].path+self.archive[file_params.index].destination+self.archive[file_params.index].filename);
                  self.OS.moveFile(self.ROUTES['CONTENT'].path+self.archive[file_params.index].filename,self.ROUTES['CONTENT'].path+self.archive[file_params.index].destination+self.archive[file_params.index].filename,function(ok){
                    self.log("Old file in content/ folder moved : "+ok);
                  });
                  $(self).trigger("FileManagerFree");
                }
              }
              if(!moved){
                self.archive[params.index].downloading = true;
                self.OS.downloadFile(url,self.ROUTES['CONTENT'].path+self.archive[file_params.index].destination,self.onFileDownloadComplete,file_params);              
              }else{
                self.busy = false;
                $(self).trigger("FileManagerFree");
              }
            },download_parameters);
          },parameters);
        }else{
          self.busy = false;
          self.log("Max Download Retries Exceeded for file "+self.archive[params.index].filename+" please check connection.");
          self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+7,self.name+": Function downloadPendingFilesInArchive() Max Download Retries Exceeded for file "+self.archive[params.index].filename+" please check connection.");
          //$(self).trigger("FileManagerFree",[true]);
        }
      }
    };

    this.downloadPendingFilesInArchive = function(){
        try{
            if(!self.archive){
                self.log("Waitting for archive to be set ...");
            }else{
                if(self.download_list.length > 0){
                    self.archive_index = self.download_list.shift();
                    self.log("Selected Archive Index : "+JSON.stringify(self.archive[self.archive_index]));
                    if(!self.busy){
                        if(!self.archive[self.archive_index].downloaded && !self.archive[self.archive_index].downloading){
                            self.log("File does Exist ? "+self.archive[self.archive_index].destination+self.archive[self.archive_index].filename);
                            self.OS.fileExists(self.ROUTES['CONTENT'].path+self.archive[self.archive_index].destination+self.archive[self.archive_index].filename, function(exists,file_ref,index){
                                self.log(file_ref);
                                var status_for = {
                                    id:self.archive[self.archive_index].identifier,
                                    player:self.core_id,
                                    name:self.name
                                };
                                if(!exists){
                                    self.log("downloadPendingFilesInArchive :"+self.archive[self.archive_index].filename+" does not exists ...");  
                                    self.getStatusFile(status_for,self.startDownloadFile,{index:self.archive_index});
                                }else{
                                    self.log("downloadPendingFilesInArchive :"+self.archive[self.archive_index].filename+" already exists ...");  
                                    self.getStatusFile(status_for,self.checkFileTimestamp,{index:self.archive_index});
                                    self.busy = false;
                                    self.busyCount = 0;
                                    $(self).trigger("FileManagerFree");
                                }
                            });
                        }
                    }else{
                      self.log("FileManager is BUSY !");
                        self.OS.fileExists(self.ROUTES['CONTENT'].path+self.archive[self.archive_index].destination+self.archive[self.archive_index].filename, function(exists,file_ref,index){
                            if(!exists){
                                self.log("Downloading ... busy");
                                self.busyCount++;
                                if(self.busyCount > 30){
                                    self.busy = false;
                                    self.busyCount = 0;
                                    self.archive_index++;
                                    $(self).trigger("FileManagerFree");
                                }
                            }else{
                                self.log("BUSY : "+self.ROUTES['CONTENT'].path+self.archive[self.archive_index].destination+self.archive[self.archive_index].filename+" already exists ...");
                                var status_for = {
                                    id:self.archive[self.archive_index].identifier,
                                    player:self.core_id,
                                    name:self.name
                                };
                                self.getStatusFile(status_for,self.checkFileTimestamp,{index:self.archive_index});
                                self.busy = false;
                                self.busyCount = 0;
                                $(self).trigger("FileManagerFree");
                            }
                        });
                    }
                }else{
                    /*
                    if(!self.selecting){
                      self.selecting = true;
                      self.review_download_list_interval = setTimeout(self.reviewDownloadList,200);
                    }
                    */
                    self.OS.readDirectory(self.ROUTES['CONTENT'].path,self.checkContentDirectory);
                    self.log("All needed files download complete ! hurray !");
                    self.busy = false;
                    self.busyCount = 0;
                    $(self).trigger("FileManagerFree",[true,true]);
                }
                
            }
        }catch(e){
            self.busy = false;
            self.log(".....................................downloadPendingFilesInArchive -- catch");
            self.log(JSON.stringify(e));
            self.download_list = [];
            self.archive_index = 0;
            self.review_index = 0;
            $(self).trigger("FileManagerFree",[true]);
        }

    };

    this.checkFileTimestamp = function(data,params){
        var download_retries = 0;
        if(typeof(params.index) !== "undefined"){
            var archive_file_stamp = false;
            if(typeof(data) == "boolean" && !data){
                archive_file_stamp = true;
                self.log("File exists archiving data tstamp.");
                self.archive[params.index].downloaded = true;
            }else{
                if(typeof(data.retries) !== "undefined"){
                  download_retries = data.retries;
                }
                if(typeof(data.tstamp) !== "undefined"){
                    //console.log("File Index : "+params.index);
                    //console.log(self.archive[params.index]);
                    //console.log("File Type : "+self.archive[params.index].type+" : File Interval "+self.archive[params.index].update_interval);
                    if(self.archive[params.index].update_interval > 0){
                      var now_tstamp = new Date().getTime();
                      var elapsed_time = now_tstamp - self.archive[params.index].update_last_interval;
                      //console.log("Elapsed : "+ elapsed_time+ " Required : "+self.archive[params.index].update_interval);
                      //self.archive[params.index].update_last_interval = now_tstamp;
                      elapsed_time = parseInt(elapsed_time/1000);
                      if(elapsed_time > self.archive[params.index].update_interval){
                        self.archive[params.index].update_last_interval = now_tstamp;
                        //console.log("Redownload..........");
                        self.log("File exists but requires re-download every "+self.archive[params.index].update_interval+"ms Mark for re-downloading ...");
                        self.OS.deleteFile(self.ROUTES['CONTENT'].path+self.archive[params.index].destination+self.archive[params.index].filename);
                        self.archive[params.index].downloaded = false;
                        download_retries = 0;
                        archive_file_stamp = true;
                        $(self).trigger("FileManagerFree");
                      }
                    }else if(data.tstamp == self.archive[params.index].tstamp){
                      self.log("File exists and it's up to date.");
                      self.archive[params.index].downloaded = true;
                    }else{
                      self.log("File exists but it's old ... deleting for re-download");
                      self.OS.deleteFile(self.ROUTES['CONTENT'].path+self.archive[params.index].destination+self.archive[params.index].filename);
                      self.archive[params.index].downloaded = false;
                      download_retries = 0;
                      archive_file_stamp = true;
                    }
                }else{
                    archive_file_stamp = true;
                    self.log("File exists archiving data tstamp.");
                    self.archive[params.index].downloaded = true;
                    //self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+6,self.name+": Function checkFileTimestamp() failed : could not check saved tstamp for content: "+self.archive[params.index].id);
                }
            }
            if(archive_file_stamp){
                var download_status = {
                    id: self.archive[params.index].identifier,
                    player: self.core_id,
                    name: self.name,
                    filename: self.archive[params.index].identifier+"/"+self.archive[params.index].filename,
                    tstamp: self.archive[params.index].tstamp,
                    retries: download_retries
                };
                self.saveStatusFile(download_status);
            }
        }else{
            self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+6,self.name+": Function checkFileTimestamp() failed : could not check index for existing file ... marking as downloaded");
        }
    };

    this.onFileDownloadComplete = function(ok,url,params){
        self.log("onFileDownloadComplete : "+ok+" URL : "+url+" Params : "+JSON.stringify(params));
        self.busy = false;
        var download_retries = 0;
        var archive_index = 0;
        if(typeof(params) != "undefined"){
          if(typeof(params.retries) != "undefined"){
            download_retries = params.retries;
            download_retries++;
          }
          if(typeof(params.index) != "undefined"){
            archive_index = params.index;
          }
        }
        self.archive[archive_index].downloading = false;
        if(typeof(self.archive[archive_index]) !== "undefined"){
          var filename = params.file_ref.substring(params.file_ref.lastIndexOf("/")+1,params.file_ref.length);
          if(ok){download_retries = 0;}
          var download_status = {
              id: self.archive[archive_index].identifier,
              player: self.core_id,
              name: self.name,
              filename: self.archive[archive_index].identifier+"/"+filename,
              tstamp: self.archive[archive_index].tstamp,
              retries: download_retries
          };
          self.saveStatusFile(download_status);
          if(ok){
            self.log("Download File completed");
            self.archive[archive_index].downloaded = true;
            self.notifyDownload(filename,params.content_id,params.content_type);
            if(params.content_type == "Adjunto"){
              if(filename.substring(filename.lastIndexOf("."),filename.length) == ".zip"){
                self.OS.unzipFile(self.ROUTES['CONTENT'].path+self.archive[archive_index].destination+filename,self.ROUTES['CONTENT'].path+self.archive[archive_index].destination,function(ok,file_ref,params){
                  self.log("Zip attachment uncompressed : "+ok);
                });
              }
              $(self).trigger("FileManagerFree");
            }
            self.OS.readDirectory(self.ROUTES['CONTENT'].path,self.checkContentDirectory);
          }else{
              if(self.download_list.indexOf(archive_index) < 0){
                self.download_list.push(archive_index);
              }
              self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+2,self.name+": Function onFileDownloadComplete() failed : could not Download file : "+self.archive[archive_index].filename+" from "+url);
              self.log(self.archive[archive_index].filename+" download error !!!");
              self.log("Error downloading file from : "+url+". Try to set Unsecure Connection for download");
              self.api_connector.setSecureConnection(false);
          }
        }
    };

    this.notifyDownload = function(filename,content_id,content_type){

        var data = "id="+self.core_id+"&content="+filename+"&content_id="+content_id+"&type="+content_type;
        self.log("Sending download notificacion : "+data.toString());
        self.api_connector.post(self.api_url,self.api_ver,"player/downloaded",data,self.notifyDownloadResponse);
    };

    this.notifyDownloadResponse = function(response,status,params){
        if(status == "success"){
            self.log("Download notified");
        }else{
            self.log("Download could not be notified");
            self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+4,self.name+": Function notifyDownloadResponse() failed : could not notify a download.");
        }
    };

    this.checkContentDirectory = function(files){
        self.log("Checking Content Directory .... ");
        if(self.archive){
            var index = 0;
            self.library = [];
            var archive_filename_list = [];
            for(var k=0;k<self.archive.length;k++){
                archive_filename_list.push(self.archive[k].id);
            }
            for(var i=0;i<files.length;i++){
                var file = files[i];
                //self.log("/content/ : "+file);
                if(file != ""){
                    if(self.platform == "SOC"){
                        file = file.substring(2,file.length-1);
                    }
                    index = archive_filename_list.indexOf(file);
                    if(index == -1){
                      if(self.weekly_archive_loaded){
                        try{
                          self.log("Deleting unneeded file : "+self.ROUTES['CONTENT'].path+file);
                          self.OS.readDirectory(self.ROUTES['CONTENT'].path+file,function(inner_files,directory_ref,parent_id){
                            if(typeof(inner_files) !== "undefined"){
                              for(var i=0;i<inner_files.length;i++){
                                  var inner_file = inner_files[i];
                                  if(inner_file != ""){
                                      if(self.platform == "SOC"){
                                          inner_file = file.substring(2,file.length-1);
                                      }
                                      self.log("Deleting : "+self.ROUTES['CONTENT'].path+parent_id+"/"+inner_file);
                                      self.OS.deleteFile(self.ROUTES['CONTENT'].path+parent_id+"/"+inner_file); 
                                  }
                              }  
                            }
                            if(typeof(parent_id) !== "undefined"){
                              var parent_filename = parent_id.substring(parent_id.lastIndexOf("/"),parent_id.length);
                              if(parent_filename.lastIndexOf(".") > 0){
                                self.OS.deleteFile(self.ROUTES['CONTENT'].path+parent_id);
                              }else{
                                self.OS.deleteDirectory(self.ROUTES['CONTENT'].path+parent_id);
                              }
                            }                  
                          },file);
                        }catch(ex){
                            self.notifyError(self.ERROR['FILE_MANAGER_SERVICE']+3,self.name+": Function checkContentDirectory() failed : error while deleting old content");
                            self.log("Error while deleting ... "+file);
                            self.log(ex.toString());
                        }
                      }
                    }else{
                        if(typeof(self.archive[index]) !== "undefined"){
                            library_index = self.library.indexOf(self.archive[index].id);
                            if(library_index == -1){
                                if(self.archive[index].id){
                                    self.OS.fileExists(self.ROUTES['CONTENT'].path+file+"/"+self.archive[index].filename,function(exists,file_ref,i){
                                      if(exists){
                                        self.library.push(self.archive[i].id);
                                        self.log("Added Id : "+self.archive[i].id);
                                      }else{
                                        self.log("Not Adding to library : Main file does not exist yet for Id = "+self.archive[i].id);
                                      }
                                    },index);
                                }else{
                                    self.log("File is an attachment : not included in Library");
                                }
                            }
                        }
                    }
                }
            }
            self.initiated = true;
            self.log("Actual library elements : "+self.library.length);
            if(files.length != self.last_files_length){
              self.last_files_length = files.length;
              if(!self.selecting){
                self.review_download_list_interval = setTimeout(self.reviewDownloadList,self.select_delay);
              }
            }
        }
    };

    this.getWeeklyArchive = function(dow,count){
        self.weekly_archive_loaded = false;
        if(typeof(count) === "undefined"){count = 1;}
        if(typeof(dow) === "undefined"){
            dow = self.getDayOfWeek();
        }else{
            if(dow >= 7){ //check!!! if dow == 8 ??
                dow = 1;
            }else{
                dow++;
            }
        }
        if(count <= 7){
            self.log("Loading XML file : "+self.ROUTES['XML'].path+dow+".xml");
            self.OS.readFile(self.ROUTES['XML'].path+dow+".xml",function(data,filename,params){
              var dataManager = new DataManagerController();
              dataManager.api_url = self.api_url;
              dataManager.api_server_url = self.api_server_url;
              $(dataManager).one("DataManagerControllerDataLoaded",{'dow':dow,'count':count},self.onDataLoaded);
              $(dataManager).one("DataManagerControllerDataError",{'dow':dow,'count':count},self.onDataError);
              try{
                dataManager.loadDataXML(data);
              }catch(e){
                  self.onDataError({'data':{'dow':dow,'count':count}});
              }            
            });
            
        }else{
            self.log("Weekly Archive Finished with files "+self.archive.length);
            self.weekly_archive_loaded = true;
            if(!self.selecting){
              self.review_download_list_interval = setTimeout(self.reviewDownloadList,self.select_delay);
            }
        }
    };

    this.onDataLoaded = function(e){
        self.archive = e.currentTarget.getArchiveFiles(self.archive);
        e.data.count++;
        self.getWeeklyArchive(e.data.dow,e.data.count);
    };

    this.onDataError = function(e){
        self.log("Error on DataManagerController for DOW : "+e.data.dow+" try next day ...");
        e.data.count++;
        self.notifyError(self.ERROR['TRANSFER_SERVICE']+16,self.name+": Function getWeeklyArchive()  :  Error on DataManagerController for DOW : "+e.data.dow+" try next day ...");
        self.getWeeklyArchive(e.data.dow,e.data.count);
    };

}
FileManagerService.prototype = new BasicService();
